Subject: Re: [PATCH net-next 1/3] ethtool: add tx aggregation parameters

From: Jakub Kicinski <[email-masked]>
Date: Mon, 14 Nov 2022 16:42:38 -0800

On Mon, 14 Nov 2022 11:06:19 +0100 Daniele Palmas wrote:
> > Isn't this the same as TX copybreak? TX
> > copybreak for multiple packets?  
> 
> I tried looking at how tx copybreak works to understand your comment,
> but I could not find any useful document. Probably my fault, but can
> you please point me to something I can read?

FWIW it's not exactly copy break, as it applies to all packets.
But there is indeed an extra copy.

Daniele's explanation is pretty solid, USB devices very often try 
to pack multiple packets into a single URB for better perf. IIUC Linux
drivers implement the feature on the Rx side, but fall short of doing
the same on the Tx side, because there's no API to control it.

I've seen the same thing in the WiFi USB devices I worked on in my
youth :)